package de.spiritlink.richhtml4eclipse.example;

import java.io.IOException;
import java.io.InputStream;
import java.net.URL;

import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.Bundle;
import org.osgi.framework.BundleContext;

/**
 * The activator class controls the plug-in life cycle
 */
public class Activator extends AbstractUIPlugin {

	// The plug-in ID
	public static final String PLUGIN_ID = "de.spiritlink.richhtml4eclipse.example";

	// The shared instance
	private static Activator plugin;
	
	/**
	 * The constructor
	 */
	public Activator() {
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext context) throws Exception {
		super.start(context);
		plugin = this;
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext context) throws Exception {
		plugin = null;
		super.stop(context);
	}

	/**
	 * Returns the shared instance
	 *
	 * @return the shared instance
	 */
	public static Activator getDefault() {
		return plugin;
	}
    
    /**
     * Gets an image from a path relative to the plugin install directory.
     *
     * @param bundle the plugin descriptor for the plugin with the image
     * @param iconPath the path relative to the install directory
     * @return the image, or null if not found
     */
    private static Image getImageFromPlugin(Bundle bundle, String iconPath) {
        InputStream is = null;
        try {
            URL installUrl = bundle.getEntry("/");
            URL url = new URL(installUrl, iconPath);
            is = url.openConnection().getInputStream();
            ImageData source = new ImageData(is);
            ImageData mask = source.getTransparencyMask();
            Image image = new Image(null, source, mask);
            return image;
        } catch (Throwable ex) {
            return null;
        } finally {
            try {
                if (is != null) is.close();
            } catch (IOException e) {
            }
        }
    }

}
