/*******************************************************************************
 * Copyright (c) 2007 Tom Seidel, Spirit Link GmbH
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * 
 * Contributors:
 *     Tom Seidel - initial API and implementation
 *******************************************************************************/
package de.spiritlink.richhtml4eclipse.example.actions;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.ui.ISharedImages;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.plugin.AbstractUIPlugin;

import de.spiritlink.richhtml4eclipse.example.dialogs.SetHtmlDialog;
import de.spiritlink.richhtml4eclipse.widgets.AllActionConstants;
import de.spiritlink.richhtml4eclipse.widgets.ComposerStatus;
import de.spiritlink.richhtml4eclipse.widgets.EventConstants;
import de.spiritlink.richhtml4eclipse.widgets.HtmlComposer;
import de.spiritlink.richhtml4eclipse.widgets.JavaScriptCommands;

/**
 * @author Tom Seidel <tom.seidel@spiritlink.de>
 * 
 */
public class SetHtmlAction extends Action {
    
    private HtmlComposer composer = null;
    
    public SetHtmlAction(HtmlComposer composer) {
        super("", IAction.AS_PUSH_BUTTON); //$NON-NLS-1$
        setToolTipText("Set HTML"); //$NON-NLS-1$
        setImageDescriptor(PlatformUI.getWorkbench().getSharedImages().getImageDescriptor(ISharedImages.IMG_OBJ_FILE));
        this.composer = composer;
    }
    
   
    
    /* (non-Javadoc)
     * @see org.eclipse.jface.action.Action#run()
     */
    @Override
    public void run() {
        SetHtmlDialog dialog = new SetHtmlDialog(this.composer.getShell());
        if (dialog.open() == IDialogConstants.OK_ID) {
            System.out.println(JavaScriptCommands.SET_HTML(dialog.getHtml()));
            this.composer.execute(JavaScriptCommands.SET_HTML(dialog.getHtml()));
        }
    }

   

}
