/*******************************************************************************
* Copyright (c) 2007 Ha Li.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*    Ha Li - initial API and implementation
*******************************************************************************/
package org.eclipse.samples.organizer.contacts.filters;

import org.eclipse.samples.organizer.Filter;
import org.eclipse.samples.organizer.models.Contact;

public class ContactFilter extends Filter {

	public static final ContactFilter instance = new ContactFilter();

	public  static final String NAME_START = "nameStartWith";
	
	private char nameStart = '*';
	
	ContactFilter() {
		super(Contact.class);
	}
	
	
	public char getNameStart() {
		return nameStart;
	}
	
	public void setNameStart(char value) {
		char oldValue = nameStart;
		nameStart = value;
		firePropertyChange(NAME_START, oldValue, value);
	}
	
}
