/*******************************************************************************
* Copyright (c) 2007 Ha Li.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*    Ha Li - initial API and implementation
*******************************************************************************/
package org.eclipse.samples.organizer.models;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;


public class Contact {	
	
	String fullName;
	String firstName;
	String middleName;
	String lastName;
	String primaryMailAddress;
	String secondMailAddress;
	String thirdMailAddress;
	int mobileNum;
	int officeNum;
	int homeNum;
	int faxNum;
	String blogAddress;
	String homePage;
	String otherInfo;
	int id;

	
	public Contact(){
		fullName = "";
		firstName = "";
		lastName = "";
		primaryMailAddress = "";
		secondMailAddress = "";
	}
	private PropertyChangeSupport propertyChangeSupport = new PropertyChangeSupport(
			this);

	public void addPropertyChangeListener(PropertyChangeListener listener) {
		propertyChangeSupport.addPropertyChangeListener(listener);
	}

	public void addPropertyChangeListener(String propertyName,
			PropertyChangeListener listener) {
		propertyChangeSupport.addPropertyChangeListener(propertyName,
				listener);
	}

	public void removePropertyChangeListener(PropertyChangeListener listener) {
		propertyChangeSupport.removePropertyChangeListener(listener);
	}

	public void removePropertyChangeListener(String propertyName,
			PropertyChangeListener listener) {
		propertyChangeSupport.removePropertyChangeListener(propertyName,
				listener);
	}

	protected void firePropertyChange(String propertyName, Object oldValue,
			Object newValue) {
		propertyChangeSupport.firePropertyChange(propertyName, oldValue,
				newValue);
	}


	public String getPrimaryMailAddress() {
		return primaryMailAddress;
	}

	public void setPrimaryMailAddress(String primaryMailAddress) {
		this.primaryMailAddress = primaryMailAddress;
	}

	public String getSecondMailAddress() {
		return secondMailAddress;
	}

	public void setSecondMailAddress(String secondMailAddress) {
		this.secondMailAddress = secondMailAddress;
	}

	public String getThirdMailAddress() {
		return thirdMailAddress;
	}

	public void setThirdMailAddress(String thirdMailAddress) {
		this.thirdMailAddress = thirdMailAddress;
	}


	public String getBlogAddress() {
		return blogAddress;
	}

	public void setBlogAddress(String blogAddress) {
		this.blogAddress = blogAddress;
	}

	public String getHomePage() {
		return homePage;
	}

	public void setHomePage(String homePage) {
		this.homePage = homePage;
	}

	public String getOtherInfo() {
		return otherInfo;
	}

	public void setOtherInfo(String otherInfo) {
		this.otherInfo = otherInfo;
	}

	public String getFullName() {
		return fullName;
	}

	public void setFullName(String fullName) {
		this.fullName = fullName;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public int getMobileNum() {
		return mobileNum;
	}

	public void setMobileNum(int mobileNum) {
		this.mobileNum = mobileNum;
	}

	public int getOfficeNum() {
		return officeNum;
	}

	public void setOfficeNum(int officeNum) {
		this.officeNum = officeNum;
	}

	public int getHomeNum() {
		return homeNum;
	}

	public void setHomeNum(int homeNum) {
		this.homeNum = homeNum;
	}

	public int getFaxNum() {
		return faxNum;
	}

	public void setFaxNum(int faxNum) {
		this.faxNum = faxNum;
	}

	public String getFirstName() {
		return firstName;
	}

	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}

	public String getMiddleName() {
		return middleName;
	}

	public void setMiddleName(String middleName) {
		this.middleName = middleName;
	}

	public String getLastName() {
		return lastName;
	}

	public void setLastName(String lastName) {
		this.lastName = lastName;
	}


} 
