package org.eclipse.samples.organizer.main;

/** Class which represents a user account */
public final class MailAccount
{
	
	private int accountID;
    /** account name */
    private String accountName;

    /** User email */
    private String email;

    /** Incoming server's type (protocol) */
    private String incomingtype;

    /** Outcoming server's type (protocol) */
    private String outgoingtype;
    
    /** Incoming server server */
    private String incomingAddress;

    /** Incoming server's port number */
    private int incomingPort;

    private boolean useSSL;

    /** Outgoing server address */
    private String outgoingAddress;

    /** Outgoing server's port number */ 
    private int outgoingPort;

    /** User login */
    private String login;

    /** User password */
    private String password;

    private String decryptedMailPassword;
    
    private boolean isDeletedFromServer;

    private MailFolder folder;
    
    private int rootFolderID;
    
    public MailAccount(){
    	
    }
	public MailAccount(String accountName, String email,String emailpassword,
			String type, String incoming, int incomingPort, boolean useSSL,
			String outgoing, int outgoingPort,MailFolder folder) {
		this.accountName = accountName;
		this.email = email;
		this.password = emailpassword;
		this.incomingAddress = incoming;
		this.incomingPort = incomingPort;
		this.useSSL = useSSL;
		this.outgoingAddress = outgoing;
		this.outgoingPort = outgoingPort;
		this.folder = folder;
	}
	public String getAccountName() {
		return accountName;
	}
	public String getEmail() {
		return email;
	}
	
	public String getIncomingAddress() {
		return incomingAddress;
	}
	public int getIncomingPort() {
		return incomingPort;
	}
	public boolean isUseSSL() {
		return useSSL;
	}
	public String getOutgoingAddress() {
		return outgoingAddress;
	}
	public int getOutgoingPort() {
		return outgoingPort;
	}
	public String getLogin() {
		return login;
	}
	public String getPassword() {
		return password;
	}
	public String getDecryptedMailPassword() {
		return decryptedMailPassword;
	}
	public MailFolder getFolder() {
		return folder;
	}
	public void setAccountName(String accountName) {
		this.accountName = accountName;
	}
	public void setEmail(String email) {
		this.email = email;
	}
	public void setIncomingAddress(String incoming) {
		this.incomingAddress = incoming;
	}
	public void setIncomingPort(int incomingPort) {
		this.incomingPort = incomingPort;
	}
	public void setUseSSL(boolean useSSL) {
		this.useSSL = useSSL;
	}
	public void setOutgoingAddress(String outgoing) {
		this.outgoingAddress = outgoing;
	}
	public void setOutgoingPort(int outgoingPort) {
		this.outgoingPort = outgoingPort;
	}
	public void setLogin(String login) {
		this.login = login;
	}
	public void setPassword(String password) {
		this.password = password;
	}
	public void setDecryptedMailPassword(String decryptedMailPassword) {
		this.decryptedMailPassword = decryptedMailPassword;
	}
	public void setFolder(MailFolder folder) {
		this.folder = folder;
	}
	public boolean isDeletedFromServer() {
		return isDeletedFromServer;
	}
	public void setDeletedFromServer(boolean isDeletedFromServer) {
		this.isDeletedFromServer = isDeletedFromServer;
	}
	public int getAccountID() {
		return accountID;
	}
	public void setAccountID(int accountID) {
		this.accountID = accountID;
	}
	public String getIncomingtype() {
		return incomingtype;
	}
	public void setIncomingtype(String incomingtype) {
		this.incomingtype = incomingtype;
	}
	public String getOutgoingtype() {
		return outgoingtype;
	}
	public void setOutgoingtype(String outgoingtype) {
		this.outgoingtype = outgoingtype;
	}
	public int getRootFolderID() {
		return rootFolderID;
	}
	public void setRootFolderID(int rootFolderID) {
		this.rootFolderID = rootFolderID;
	}

}
