/*******************************************************************************
* Copyright (c) 2007 Ha Li.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*    Ha Li - initial API and implementation
*/
package org.eclipse.samples.organizer.main;

import java.util.ArrayList;
import java.util.List;

/**
 * Logic class stands folder in tree
 * @author Ha Li
 */
public final class  MailFolder {


	private String folderName;
	private int folderID;
	private boolean isAccount;
	private int unreadMessageCount;
	private int accountID;
	private int parentFolderID;
	private List<MailFolder> subfolders = new ArrayList<MailFolder>();
	private MailFolder parent;
    private String folderFilePath;
	private boolean systemfoldersymbol = true;
	
	public MailFolder(String name,String accountname) {
		this.folderName = name;
		 isAccount = false;
		 unreadMessageCount =0;
		// this.accountName = accountname;
	}

	public MailFolder() {
		this(null,"root");
		
	}

	public Object getParent() {
		return parent;
	}

	public Object[] getChildren() {
		return (MailFolder[]) subfolders.toArray(new MailFolder[subfolders.size()]);
	}

	public boolean hasChildren() {
		return !subfolders.isEmpty();
	}

	public void add(MailFolder mailFolder) {
		subfolders.add(mailFolder);
		mailFolder.setParent(this);
	}

	private void setParent(MailFolder parent) {
		this.parent = parent;			
	}

	
	public boolean isAccount(){
		return isAccount;
	}
	
	public void setIsAccount(boolean value){
		
		isAccount = value;
	}

	public int getUnreadMessageCount() {
		return unreadMessageCount;
	}

	public void setUnreadMessageCount(int unreadMessageCount) {
		this.unreadMessageCount = unreadMessageCount;
	}

	public int getFolderID() {
		return folderID;
	}

	public void setFolderID(int folderID) {
		this.folderID = folderID;
	}

	public int getAccountID() {
		return accountID;
	}

	public void setAccountID(int accountID) {
		this.accountID = accountID;
	}

	public String getFolderFilePath() {
		return folderFilePath;
	}

	public void setFolderFilePath(String folderFilePath) {
		this.folderFilePath = folderFilePath;
	}
	public String getFolderName() {
		return folderName;
	}
	
	public void setFolderName(String name){
		folderName = name;
	}

	public int getParentFolderID() {
		return parentFolderID;
	}

	public void setParentFolderID(int parentFolderID) {
		this.parentFolderID = parentFolderID;
	}

	public boolean isSystemfoldersymbol() {
		return systemfoldersymbol;
	}

	public void setSystemfoldersymbol(boolean systemfoldersymbol) {
		this.systemfoldersymbol = systemfoldersymbol;
	}
	

}
