package org.eclipse.samples.organizer.util;

import java.io.File;
import java.io.IOException;
import java.util.LinkedList;
import java.util.List;
import java.util.Random;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.eclipse.samples.organizer.main.MailAccount;
import org.eclipse.samples.organizer.main.MailFolder;
import org.eclipse.samples.organizer.main.MailManager;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

public class AccountsDeal {
	public static final String DEFAULT_ACCOUNT_FILE = "accounts.xml";

	
	
	
	public static void createFileAccount(MailAccount account) {
		Element tempAccount;
		Element temp;
		Element tempSub;
		XmlCreater xc = new XmlCreater(DEFAULT_ACCOUNT_FILE);
		//Create root Element;
		xc.createRootElement("Accounts");
		//Create Acount Element and add Account Name attribute
		tempAccount = xc.createElement(xc.root, "Account");
		xc.createAttribute(tempAccount, "Name", account.getAccountName());
	    
		//Create AccountInfo Element
		temp = xc.createElement(tempAccount, "AccountInfo");
		xc.createAttribute(temp, "EmailAddress",account.getEmail());
		xc.createAttribute(temp, "EmailPassword",account.getPassword());
		
		//Create Server info Element
		temp = xc.createElement(tempAccount, "ServerInfo");
		xc.createAttribute(temp, "incoming",account.getIncoming());
		xc.createAttribute(temp, "incomingPort",new Integer(account.getIncomingPort()).toString());
		xc.createAttribute(temp, "type",account.getType());
		xc.createAttribute(temp, "useSSL",new Boolean(account.isUseSSL()).toString());
		xc.createAttribute(temp, "outgoing",account.getOutgoing());
		xc.createAttribute(temp, "outgoingPort",new Integer(account.getOutgoingPort()).toString());
		
		//Create Folder info Element
		temp = xc.createElement(tempAccount, "FolderInfo");
		tempSub = xc.createElement(temp, "MailFolder");
		xc.createAttribute(tempSub, "foldername", DEFAULT_INBOX_FOLDER);
		xc.createAttribute(tempSub, "folderID", radomIntCreate().toString());
		tempSub = xc.createElement(temp, "MailFolder");
		xc.createAttribute(tempSub, "foldername", DEFAULT_OUTBOX_FOLDER);
		xc.createAttribute(tempSub, "folderID", radomIntCreate().toString());
		tempSub = xc.createElement(temp, "MailFolder");
		xc.createAttribute(tempSub, "foldername", DEFAULT_SENT_FOLDER);
		xc.createAttribute(tempSub, "folderID", radomIntCreate().toString());
		tempSub = xc.createElement(temp, "MailFolder");
		xc.createAttribute(tempSub, "foldername", DEFAULT_TRASH_FOLDER);
		xc.createAttribute(tempSub, "folderID", radomIntCreate().toString());
		tempSub = xc.createElement(temp, "MailFolder");
		xc.createAttribute(tempSub, "foldername", DEFAULT_DRAFT_FOLDER);
		xc.createAttribute(tempSub, "folderID", radomIntCreate().toString());
		xc.buildXmlFile();
	}
	
	public static void addAccountToFile(MailAccount account) {
		Element tempAccount;
		Element temp;
		Element tempSub;
		XmlCreater xc = new XmlCreater(DEFAULT_ACCOUNT_FILE);
		xc.root = xc.getDoc().getDocumentElement();
		
		//Create root Element;
		xc.createRootElement("Accounts");
		//Create Acount Element and add Account Name attribute
		tempAccount = xc.createElement(xc.root, "Account");
		xc.createAttribute(tempAccount, "Name", account.getAccountName());
	    
		//Create AccountInfo Element
		temp = xc.createElement(tempAccount, "AccountInfo");
		xc.createAttribute(temp, "EmailAddress",account.getEmail());
		xc.createAttribute(temp, "EmailPassword",account.getPassword());
		
		//Create Server info Element
		temp = xc.createElement(tempAccount, "ServerInfo");
		xc.createAttribute(temp, "incoming",account.getIncoming());
		xc.createAttribute(temp, "incomingPort",new Integer(account.getIncomingPort()).toString());
		xc.createAttribute(temp, "type",account.getType());
		xc.createAttribute(temp, "useSSL",new Boolean(account.isUseSSL()).toString());
		xc.createAttribute(temp, "outgoing",account.getOutgoing());
		xc.createAttribute(temp, "outgoingPort",new Integer(account.getOutgoingPort()).toString());
		
		//Create Folder info Element
		temp = xc.createElement(tempAccount, "FolderInfo");
		tempSub = xc.createElement(temp, "MailFolder");
		xc.createAttribute(tempSub, "foldername", DEFAULT_INBOX_FOLDER);
		xc.createAttribute(tempSub, "folderID", radomIntCreate().toString());
		tempSub = xc.createElement(temp, "MailFolder");
		xc.createAttribute(tempSub, "foldername", DEFAULT_OUTBOX_FOLDER);
		xc.createAttribute(tempSub, "folderID", radomIntCreate().toString());
		tempSub = xc.createElement(temp, "MailFolder");
		xc.createAttribute(tempSub, "foldername", DEFAULT_SENT_FOLDER);
		xc.createAttribute(tempSub, "folderID", radomIntCreate().toString());
		tempSub = xc.createElement(temp, "MailFolder");
		xc.createAttribute(tempSub, "foldername", DEFAULT_TRASH_FOLDER);
		xc.createAttribute(tempSub, "folderID", radomIntCreate().toString());
		tempSub = xc.createElement(temp, "MailFolder");
		xc.createAttribute(tempSub, "foldername", DEFAULT_DRAFT_FOLDER);
		xc.createAttribute(tempSub, "folderID", radomIntCreate().toString());
		
		xc.buildXmlFile();

	}
	
	public static List<MailAccount>  readAccountFromLocal() {
		List<MailAccount> accounts = new LinkedList<MailAccount>();
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder = null;
		Document document = null;
		try {
			builder = factory.newDocumentBuilder();
		} catch (ParserConfigurationException e) {
			e.printStackTrace();
		}

		try {

			document = builder.parse(DEFAULT_ACCOUNT_FILE);

		} catch (SAXException e) {

			e.printStackTrace();
		} catch (IOException e) {

		}

		Element accountElement = document.getDocumentElement();
		NodeList accountsList = accountElement.getElementsByTagName("Account");
		for (int i = 0, len = accountsList.getLength(); i < len; i++) {
			//Get the accountName for the number i account node
			Element account = (Element) accountsList.item(i);
			String acountName = account.getAttribute("Name");

			NodeList accountInfo = account.getElementsByTagName("AccountInfo");
			String emailAddress= ((Element)accountInfo.item(0)).getAttribute("EmailAddress");
			String password= ((Element)accountInfo.item(0)).getAttribute("EmailPassword");
			
			NodeList serverInfo = account.getElementsByTagName("ServerInfo");
			String incomingAddress= ((Element)serverInfo.item(0)).getAttribute("incoming");
			int incomingPort= Integer.parseInt(((Element)serverInfo.item(0)).getAttribute("incomingPort"));
			String outgoingAddress= ((Element)serverInfo.item(0)).getAttribute("outgoing");
			int outgoingPort = Integer.parseInt(((Element)serverInfo.item(0)).getAttribute("outgoingPort"));
			
			NodeList mailFolderList = account
					.getElementsByTagName("FolderInfo");
			Element mailFolderRoot = (Element) mailFolderList.item(0);
			NodeList subMailFolderList = mailFolderRoot
					.getElementsByTagName("MailFolder");
            //Account Element
			MailFolder mailFolderInfo = new MailFolder(acountName,acountName);
			mailFolderInfo.setIsAccount(true);
			
			for (int j = 0, temlen = subMailFolderList.getLength(); j < temlen; j++) {

				Element mailFolder = (Element) subMailFolderList.item(j);
				MailFolder tempFolder = new MailFolder(mailFolder
						.getAttribute("foldername"),acountName);
				tempFolder.setFolderFilePath(FolderDeal.DEFAULT_ACCOUNT_FOLDER +
						File.separator +
						tempFolder.getAccountName() +
						mailFolder.getAttribute("foldername")+ ".data");
				tempFolder.setFolderID(Integer.parseInt(mailFolder.getAttribute("folderID")));
				//MailManager.getInstance().getFolderMap().put(tempFolder.getFolderID(), tempFolder);
				mailFolderInfo.add(tempFolder);
			}
			accounts.add(new MailAccount(acountName,
					emailAddress,
					password,
			"pop3",
			incomingAddress,
			110,
			false,
			outgoingAddress,
			25,
			mailFolderInfo));
		}
       return accounts;
	}
	
	public static Integer radomIntCreate(){
	   Random rand = new Random();
	  return rand.nextInt(Integer.MAX_VALUE);
		
	}
}
