package org.eclipse.samples.organizer;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;

import org.eclipse.samples.organizer.backend.Backend;

/**
 * 
 * @author Wayne Beaton
 * TODO This should be a service?
 * Hook and unhook content change listener with service lifecycle.
 */
public class Filter {
	Class<?>[] types;
	Backend[] backends;
	
	public Filter() {
	}
	
	public Filter(Class<?> type) {
		types = new Class[] {type};
	}
	
	public Class<?>[] getTypes() {
		return types;
	}

	public void setTypes(Class<?>[] types) {
		this.types = types;
	}
	
	public Backend[] getBackends() {
		return backends;
	}
	
	public void setBackends(Backend[] backends) {
		this.backends = backends;
	}

	public boolean includesType(Class<?> targetType) {
		if (types == null) return true;
		for (Class<?> type : types) {
			if (type == targetType) return true;
		}
		return false;
	}	
	
	/*
	 * ============================================
	 * Property Change Support methods
	 * ============================================
	 */
	private PropertyChangeSupport propertyChangeSupport = new PropertyChangeSupport(this);
	
	public void addPropertyChangeListener(PropertyChangeListener listener) {
		propertyChangeSupport.addPropertyChangeListener(listener);
	}

	public void addPropertyChangeListener(String propertyName,
			PropertyChangeListener listener) {
		propertyChangeSupport.addPropertyChangeListener(propertyName,
				listener);
	}

	public void removePropertyChangeListener(PropertyChangeListener listener) {
		propertyChangeSupport.removePropertyChangeListener(listener);
	}

	public void removePropertyChangeListener(String propertyName,
			PropertyChangeListener listener) {
		propertyChangeSupport.removePropertyChangeListener(propertyName,
				listener);
	}
	
	protected void firePropertyChange(String propertyName, Object oldValue,
			Object newValue) {
		propertyChangeSupport.firePropertyChange(propertyName, oldValue,
				newValue);
	}
}
