/*******************************************************************************
 * Copyright (c) 2006 The Eclipse Foundation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *    The Eclipse Foundation - initial API and implementation
 *******************************************************************************/
package org.eclipse.samples.organizer.backend;

import java.util.List;

import org.eclipse.samples.organizer.Filter;
import org.eclipse.samples.organizer.Visitor;
import org.eclipse.samples.organizer.exceptions.BackendException;

public interface Backend {
	String getName();
	
	/**
	 * The add method is used to add a collection of objects
	 * to the backend.
	 * @param object
	 * @throws BackendException
	 */
	void add(List<?> objects) throws BackendException;
	void find(Filter filter, Visitor visitor) throws BackendException;
	void delete(List<?> objects) throws BackendException;

	int count(Filter filter) throws BackendException;
	
	// TODO Class getSupportedTypes();
}
