/*******************************************************************************
 * Copyright (c) 2006 The Eclipse Foundation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *    The Eclipse Foundation - initial API and implementation
 *******************************************************************************/
package org.eclipse.samples.organizer.derby;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.samples.organizer.OrganizerManager;
import org.eclipse.samples.organizer.backend.Backend;
import org.eclipse.samples.organizer.backend.BackendFactory;

public class ContactDerbyBackendFactory implements BackendFactory {

	ContactDerbyBackend backend;
	

	public void initialize(OrganizerManager manager) throws Exception {
		backend = buildBackend();
		backend.initialize(manager);
	}

	public List<Backend> getBackends() {
		List<Backend> list = new ArrayList<Backend>();
		list.add(backend);
		return list;
	}

	public void shutdown() throws Exception {
		backend.shutdown();
	}
	
	private ContactDerbyBackend buildBackend() {
		return new ContactDerbyBackend(Database.derbyInstance);
	}
}
