package org.eclipse.samples.organizer.derby;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

import org.apache.derby.jdbc.EmbeddedDriver;

public class Database {

	private String databaseUrl;
	
	// FIXME This should not be defined here. Perhaps it will make a good OSGi Service (or something) which would solve the shutdown problem.
	public static final Database derbyInstance;
	
	static {
		try {
			DriverManager.registerDriver(new EmbeddedDriver());
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		derbyInstance = new Database("jdbc:derby:" + System.getProperty("user.home") + System.getProperty("file.separator") + ".organizerDb;create=true");
	}
	
	public Database(String databaseUrl) {
		this.databaseUrl = databaseUrl;
	}

	public Connection getConnection() throws SQLException {
		return DriverManager.getConnection(databaseUrl);
	}
}
