/*******************************************************************************
 * Copyright (c) 2006 The Eclipse Foundation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *    The Eclipse Foundation - initial API and implementation
 *******************************************************************************/
package org.eclipse.samples.organizer.dnd.outlook;

import java.util.HashMap;
import java.util.Map;

public class TabbedDataExtractor {
	@SuppressWarnings("unchecked")
	public static Map<String, String>[] getData(String source) {
		String[] lines = source.split("\n");
		String[] headers = lines[0].split("\t");
		Map<String, String>[] result = new Map[lines.length-1];
		for(int index=1;index<lines.length;index++) {
			String[] entries = lines[index].split("\t");
			Map<String, String> map = new HashMap<String, String>();
			for (int j=0;j<headers.length;j++) {
				if (j >= entries.length) break;
				map.put(headers[j], entries[j]);
			}
			result[index-1] = map;
		}
		return result;
	}
}
