/*******************************************************************************
* Copyright (c) 2007 Ha Li.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*    Ha Li - initial API and implementation
*******************************************************************************/
package org.eclipse.samples.organizer.ui.contact.dnd;

import java.util.List;

import org.eclipse.samples.organizer.models.Contact;
import org.eclipse.swt.dnd.DropTargetEvent;
import org.eclipse.swt.dnd.Transfer;

public interface DropHandler {
	public Transfer[] getSupportedTransfers();
	
	/**
	 * This method returns a List of Task instances created from
	 * the data provided by the DropTargetEvent. If tasks cannot
	 * be created by the instance, null is returned. 
	 * @param event
	 * @return a List of Tasks, or null if this drop handler is
	 * in appropriate for the event.
	 */
	public List<Contact> createContactsFromDropEvent(DropTargetEvent event);
	public Integer getWeight();
}
