/*******************************************************************************
* Copyright (c) 2007 Ha Li.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*    Ha Li - initial API and implementation
*******************************************************************************/
package org.eclipse.samples.organizer.ui.contact.wizards;

import java.util.List;

import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.samples.organizer.models.Contact;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

public class ImportManyContactsWizardPage extends WizardPage {

	private final List<Contact> contacts;

	public ImportManyContactsWizardPage(List<Contact> contacts) {
		super("Multiple Tasks");
		this.contacts = contacts;

		setTitle("Import multiple contacts");
	}
	
	public void createControl(Composite parent) {
		Composite composite =  new Composite(parent, SWT.NONE);
		Label label = new Label(composite, SWT.NONE);
		composite.setLayout(new GridLayout(1, false));
		label.setText("Import " + contacts.size() + " contacts.");
		setControl(composite);
	}
}
