/*******************************************************************************
* Copyright (c) 2007 Ha Li.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*    Ha Li - initial API and implementation
*/
package org.eclipse.samples.organizer.ui.mail.actions;

import java.util.List;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.samples.organizer.main.MailManager;
import org.eclipse.samples.organizer.models.Mail;
import org.eclipse.samples.organizer.ui.mail.Activator;
import org.eclipse.samples.organizer.ui.mail.editors.MailEditor;
import org.eclipse.samples.organizer.ui.mail.main.ExtendedMessage;
import org.eclipse.samples.organizer.ui.mail.util.MailPathProducer;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.actions.ActionFactory;

public class CreateMailAction extends Action {
  private List<String> receiverList;
	public CreateMailAction(List<String> _receiverList){
		super();
		receiverList = _receiverList;
		this.setText("New Mail");
		this.setToolTipText("Create a new mail!");
		this.setImageDescriptor(ImageDescriptor
				.createFromImage(Activator.getDefault().getImage(
						Activator.IMAGE_MAIL_DRAFT)));
		this.setDisabledImageDescriptor(ImageDescriptor
				.createFromImage(Activator.getDefault().getImage(
						Activator.IMAGE_MAIL_OUT)));
		this.setActionDefinitionId(ActionFactory.NEW.getId());
	}
	@Override
	public void run() {
		final Mail mail = new Mail();
		StringBuilder receveString = new StringBuilder("");
		for(int i= 0,len = receiverList.size(); i< len; i++){
			receveString.append(receiverList.get(i));
		}
		mail.setReceivers(receveString.toString());
		mail.setAccountID(MailManager.getInstance()
				.getCurrentaccount().getAccountID());
		mail.setNewCreated(true);
		final ExtendedMessage message = new ExtendedMessage();
		MailPathProducer.producePath(mail, "Draft");
		Display.getDefault().asyncExec(new Runnable() {
            public void run() {
            	MailEditor mv = new MailEditor(mail,message);
				mv.show();
            }
		});
		
	}


}
