/*******************************************************************************
* Copyright (c) 2007 Ha Li.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*    Ha Li - initial API and implementation
*/
package org.eclipse.samples.organizer.ui.mail.actions;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.jface.action.Action;
import org.eclipse.samples.organizer.exceptions.BackendException;
import org.eclipse.samples.organizer.main.MailManager;
import org.eclipse.samples.organizer.models.Mail;
import org.eclipse.samples.organizer.ui.mail.jobs.DeleteMessageJob;

public class EmptyFolderAction extends Action {
   private int folderid;
   private List<Mail> mailList;
	public EmptyFolderAction(int folderID) {
		folderid = folderID;
		mailList = new ArrayList<Mail>();
	}

	public void run(){
		try {
			MailManager.getInstance().fetchMails(mailList, folderid);
		} catch (BackendException e) {
			e.printStackTrace();
		}
		new DeleteMessageJob(mailList).schedule();
	}
}
