/*******************************************************************************
* Copyright (c) 2007 Ha Li.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*    Ha Li - initial API and implementation
*/
package org.eclipse.samples.organizer.ui.mail.actions;

import org.eclipse.jface.action.Action;
import org.eclipse.samples.organizer.main.MailManager;
import org.eclipse.samples.organizer.ui.mail.jobs.Pop3GetAndDelFromServerJob;
import org.eclipse.samples.organizer.ui.mail.jobs.Pop3GetJob;

public class ReceiveMailAction extends Action {
    private int accountID;
	public ReceiveMailAction(int id) {
		accountID = id;
	}
	
	public void run(){
		if(MailManager.getInstance().getAccountFromID(accountID).isDeletedFromServer()){
			new Pop3GetAndDelFromServerJob(accountID).schedule();
		}
		else{
			new Pop3GetJob(accountID).schedule();
		}
	}
}
