/*******************************************************************************
* Copyright (c) 2007 Ha Li.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*    Ha Li - initial API and implementation
*/
package org.eclipse.samples.organizer.ui.mail.jobs;


import org.eclipse.core.runtime.jobs.Job;
import org.eclipse.samples.organizer.main.MailAccount;
import org.eclipse.samples.organizer.main.MailManager;

public abstract class BasicJob extends Job {
    protected MailAccount account;

	
    protected BasicJob(String name,int accountid) {
		super(name);
		this.account = MailManager.getInstance().getAccountFromID(
				accountid);
	}

    protected String getSMTPAddress(){
    	return account.getOutgoingAddress();
    }
    
    protected String getEmailAdress(){
    	return account.getEmail();
    }
    protected String getEmailPassword(){
    	return account.getPassword();
    }
    
    
    protected int getSMTPPort(){
    	if(account.getOutgoingPort()==0)
    		return 25;
    	return account.getOutgoingPort();
    }
    protected String getReceiveProtocolType(){
    	return account.getIncomingtype();
    }
    protected String getReceiveServerAddress(){
    	return account.getIncomingAddress();
    }
    protected int getReceiveServerPort(){
    	if(account.getIncomingPort()==0)
    		return 110;
    	return account.getIncomingPort();
    }
    
    protected boolean isPop3GetJobDeleteFromServer()
    {
    	return account.isDeletedFromServer();
    }
    
    

}