/*******************************************************************************
* Copyright (c) 2007 Ha Li.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*    Ha Li - initial API and implementation
*/
package org.eclipse.samples.organizer.ui.mail.jobs;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.samples.organizer.main.MailManager;
import org.eclipse.samples.organizer.ui.mail.jobs.BasicJob;

public class Pop3InternalGetJob extends BasicJob {
	private int intervalTime;
	private int accountid;

	public Pop3InternalGetJob(int id, int time) {
		super("Internally receiving mails from " + MailManager.getInstance().getAccountFromID(id).getAccountName(), id);
		this.intervalTime = time;
		this.accountid = id;
	}

	@Override
	public IStatus run(IProgressMonitor monitor) {
		new MessageInternalGet().start();
		return Status.OK_STATUS;

	}

	class MessageInternalGet extends Thread {
		public void run() {
			while (true) {
				try {
					//the time is minutes.
					Thread.sleep(intervalTime * 1000 * 60);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
				if (isPop3GetJobDeleteFromServer()) {
					Pop3GetAndDelFromServerJob pop3deljob = new Pop3GetAndDelFromServerJob(
							accountid);
					pop3deljob.schedule();

				} else {
					Pop3GetJob pop3getjob = new Pop3GetJob(accountid);
					pop3getjob.schedule();
				}
			}
		}
	}
}
