/*******************************************************************************
* Copyright (c) 2007 Ha Li.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*    Ha Li - initial API and implementation
*/
package org.eclipse.samples.organizer.ui.mail.util;

import java.io.File;

import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.program.Program;
import org.eclipse.swt.widgets.Display;

/** Use for attachment
 * File icon provider. A display object must be created before 
 * 
 */
public class FileUtil {
  static ImageRegistry imageRegistry;
  
  static Image iconFile;
  
/* static {
    iconFile = new Image(Display.getCurrent(),Activator.IMAGE_MAIL_DRAFT);
  }*/

  /**
   * Returns an icon representing the specified file.
   * 
   * @param file
   * @return
   */
  public static Image getIcon(File file) {
  

    int lastDotPos = file.getName().indexOf('.');
    if (lastDotPos == -1)
      return iconFile;

    Image image = getIcon(file.getName().substring(lastDotPos + 1));
    return image == null ? iconFile : image;
  }

  
  /**
   * Returns the icon for the file type with the specified extension.
   * 
   * @param extension
   * @return
   */
  private static Image getIcon(String extension) {
    if (imageRegistry == null)
      imageRegistry = new ImageRegistry();
    Image image = imageRegistry.get(extension);
    if (image != null)
      return image;

    Program program = Program.findProgram(extension);
    ImageData imageData = (program == null ? null : program.getImageData());
    if (imageData != null) {
      image = new Image(Display.getCurrent(), imageData);
      imageRegistry.put(extension, image);
    } else {
      image = iconFile;
    }
    return image;
  }  
  
  public static String transferFileSize(long filesize){
	  if(filesize<=1024)
		  return "1K";
	  else if(filesize>1024&& filesize<1024*1024)
		  return String.valueOf((int)filesize/1024)+ "K";
	 
	  else return String.valueOf((int)filesize/(1024*1024)) + "M";
	
  }
  
  public static void main(String args[]){
	 System.out.print(transferFileSize(50));
  }
  
}