package org.eclipse.samples.organizer.ui.model;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Widget;
import org.eclipse.ui.plugin.AbstractUIPlugin;

public class DefaultFeatureHelper implements FeatureHelper {

	private Color background;
	private Image image;

	public void createSwitcherContentArea(Composite parent) {
		parent.setLayout(new FillLayout());
		Label label = new Label(parent, SWT.CENTER);
		allocateResources(label);
		label.setBackground(background);
		label.setImage(image);		
	}

	private void allocateResources(Widget widget) {
		ImageDescriptor descriptor = AbstractUIPlugin.imageDescriptorFromPlugin(Activator.getDefault().getBundle().getSymbolicName(), "/icons/eclipse.png");
		image = descriptor.createImage();
		background = new Color(widget.getDisplay(), new RGB(67, 7, 119));
		
		widget.addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent e) {
				image.dispose();
				background.dispose();
			}			
		});
	}

	public void configureSwitcherButton(Button button) {
		// Do nothing		
	}

	public String getSummary() {
		return "";
	}

}
