//TODO move this class.
package org.eclipse.samples.organizer.ui.model;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;

import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.core.runtime.IExtensionPoint;
import org.eclipse.core.runtime.IExtensionRegistry;
import org.eclipse.core.runtime.Platform;

public class OrganizerViewModel {
	// TODO Move this, or better yet stop using a singleton altogether.
	public static final OrganizerViewModel instance = new OrganizerViewModel();

	public static final String ACTIVE_FEATURE = "activeFeature";
	public static final String SWITCHER_STYLE = "switcherStyle";
	
	PropertyChangeSupport propertyChangeSupport = new PropertyChangeSupport(this);
	
	public enum SwitcherStyle {Buttons, ButtonsWithText};
	
	SwitcherStyle switcherStyle = SwitcherStyle.ButtonsWithText;

	public SwitcherStyle getSwitcherStyle() {
		return switcherStyle;
	}

	public void setSwitcherStyle(SwitcherStyle style) {
		SwitcherStyle oldValue = this.switcherStyle;
		this.switcherStyle = style;
		firePropertyChange(SWITCHER_STYLE, oldValue, style);
	}

	Feature[] features;

	private Feature activeFeature;	
	
	public Feature[] getFeatures() {
		if (features == null) computeFeatures();
		return features;
	}

	private void computeFeatures() {
		IExtensionRegistry registry = Platform.getExtensionRegistry();
		IExtensionPoint point = registry.getExtensionPoint(Activator.PLUGIN_ID + ".feature");
		IConfigurationElement[] elements = point.getConfigurationElements();
		features = new Feature[elements.length];
		for (int index=0;index<elements.length;index++) {
			IConfigurationElement element = elements[index];
			features[index] = new Feature(element);
		}
	}

	public Feature getActiveFeature() {
		if (activeFeature == null) activeFeature = getFeatures()[0];
		return activeFeature;
	}

	public void setActiveFeature(Feature feature) {
		if (feature == this.activeFeature) return;
		Feature oldValue = this.activeFeature;
		this.activeFeature = feature;
		firePropertyChange(OrganizerViewModel.ACTIVE_FEATURE, oldValue, feature);
	}
	
	public void addPropertyChangeListener(PropertyChangeListener listener) {
		propertyChangeSupport.addPropertyChangeListener(listener);
	}

	public void addPropertyChangeListener(String propertyName,
			PropertyChangeListener listener) {
		propertyChangeSupport.addPropertyChangeListener(propertyName,
				listener);
	}

	public void removePropertyChangeListener(PropertyChangeListener listener) {
		propertyChangeSupport.removePropertyChangeListener(listener);
	}

	public void removePropertyChangeListener(String propertyName,
			PropertyChangeListener listener) {
		propertyChangeSupport.removePropertyChangeListener(propertyName,
				listener);
	}

	protected void firePropertyChange(String propertyName, Object oldValue,
			Object newValue) {
		propertyChangeSupport.firePropertyChange(propertyName, oldValue,
				newValue);
	}

}
