/*******************************************************************************
 * Copyright (c) 2006 The Eclipse Foundation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *    The Eclipse Foundation - initial API and implementation
 *******************************************************************************/
package org.eclipse.samples.organizer.ui.task.wizards;

import java.util.List;

import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.samples.organizer.models.Task;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

public class ImportManyTasksWizardPage extends WizardPage {

	private final List<Task> tasks;

	public ImportManyTasksWizardPage(List<Task> tasks) {
		super("Multiple Tasks");
		this.tasks = tasks;

		setTitle("Import multiple tasks");
	}
	
	public void createControl(Composite parent) {
		Composite composite =  new Composite(parent, SWT.NONE);
		Label label = new Label(composite, SWT.NONE);
		composite.setLayout(new GridLayout(1, false));
		label.setText("Import " + tasks.size() + " tasks.");
		setControl(composite);
	}
}
