package org.eclipse.samples.organizer.ui.util;

import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;

public class CellEvent {

	protected final Event event;

	public CellEvent(Event event) {
		this.event = event;
	}

	public TableItem getTableItem() {
		return (TableItem) event.item;
	}

	public Table getTable() {
		return (Table) event.widget;
	}

	public TableColumn getTableColumn() {
		return getTable().getColumn(event.index);
	}

	public TableViewerColumnDefinition getColumnDefinition() {
		return (TableViewerColumnDefinition) getTableColumn().getData("super_column");
	}

	public Rectangle getCellBounds() {
		return new Rectangle(event.x, event.y, getTableColumn().getWidth(), event.height);
	}

	public boolean isSelected() {
		if (!getTable().isFocusControl())
			return false;
		for (TableItem selected : getTable().getSelection()) {
			if (selected == getTableItem())
				return true;
		}
		return false;
	}

	public Object getObject() {
		return getTableItem().getData();
	}

	public GC getGC() {
		return event.gc;
	}

}